<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.plugin');


class plgContentSecretpage extends JPlugin
{
    public static $CookieName = 'qTy78SbecReLoc1';
    private static $_signal_key = 'secretpagessuccesssubscribeentercode';
    private static $_is_loaded = false;
    
    private $_on = false;
    private $_abs_assets, $_assets_url; // assets folder
    private $_smartresponder;
    
	public function __construct(& $subject, $config){
		parent::__construct($subject, $config);
	}
    
    // for >= 1.6
    function onContentPrepare($context, &$row, &$params, $page=0){
        if(self::$_is_loaded) return; self::$_is_loaded = true;
        $assets = '/plugins/' . $this->_type . '/' . $this->_name . '/secretpage/assets/';
        $context = str_replace('com_content.', '', $context);
        $this->_onOn($context, $row, $assets);
    }
    
    
    // for 1.5
	function onPrepareContent( &$article, &$params, $limitstart ){  
	   if(self::$_is_loaded) return; self::$_is_loaded = true;
       $assets = '/plugins/' . $this->_type . '/' . $this->_name . '/assets/';
       $context = $_GET['view'];
       	  
       $this->_onOn($context, $article, $assets);       
	}
    
    
    private function _onOn($context, $row, $assets_folder){
        
        if($_COOKIE[self::$CookieName]) return; // subscriber is
        
        $this->_abs_assets = JPATH_BASE . $assets_folder; 
        $this->_assets_url = JURI::root() . $assets_folder;        
        
        if(stripos($_SERVER['REQUEST_URI'], $this->params->get('signal_key')) !== false){
           if($_COOKIE['plgSecretpageReturnPage']){
              setcookie('plgSecretpageReturnPage', 0, 1000, '/');  
              $location = $_COOKIE['plgSecretpageReturnPage'].'/#enterCode';
              $location = str_replace('//#enterCode', '/#enterCode', $location);
              exit(header('Location: '.$location));  
          }
        } 
        else{
            if($context != 'article') return; // not view article
            isset($_GET[self::$CookieName]) ? $this->_handlerForm() : $this->_contentPrepare($row);            
        }             
        return true;
    }
    

    /** 
     * @param stdClass Object current article
    */
    private function _contentPrepare($article){
        
        $style = $this->params->get('style');
        $categorys = $this->params->get('categorys');
        $timeOut = 10; 

        if(!$categorys or !$style) return; // settings not defined 
        
        if(!is_array($categorys)) $categorys = array($categorys);
        
        if(!in_array($article->catid, $categorys)) return;


        
        $document =& JFactory::getDocument();
        
        // add css
        $style = $this->_assets_url  . 'styles/' .$style;
        $loading_img = $style . '/preloader.gif';
        $style .= '/css.css';
        $document->addStyleSheet($style);
        
        // add loading-img
        $this->params->set('loading_img', $loading_img);
        
        // add js
        $script = $this->_assets_url  . 'js.js'; 
        if($this->params->get('add_jquery')){
            $document->addScript('http://ajax.googleapis.com/ajax/libs/jquery/1.8/jquery.min.js');  
            $document->addScriptDeclaration('jQuery.noConflict();');  
        }
        
        $html = $this->_getPluginHtml();
              
        $document->addScriptDeclaration("jQuery(function(){jQuery('$html').appendTo('body'); setTimeout(function(){jQuery.getScript('$script')}, $timeOut)});");
        
        $this->_on = true;        
    }
    
    private function _handlerForm(){
        if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') exit();
        
        require_once $this->_abs_assets . 'cls/cls.php';
        
        $params = $this->params->toArray();

        $smartresponder = new SmartResponderApi(
            $this->params->get('smart_api_id'), 
            $this->params->get('smart_api_pass'), 
            $this->params->get('smart_api_delivery_id')
        );
        
        $recoveryTemplate = str_replace('&#13;&#10;', "\n", $this->params->get('smart_api_recoveryTemplate'));
        $recoveryTemplate = str_replace('{{secret_key}}',  $this->params->get('secret_key'), $recoveryTemplate);
        
        $handler = new SecretPageHandler($smartresponder, $_GET, self::$CookieName); 
        $handler->set('recoveryTemplate', $recoveryTemplate);
        $handler->set('secret_key', $this->params->get('secret_key'));
        
        $handler->execute();
    }
    
    // add html-form-tpl
    function _getPluginHtml(){
        
        // close url 
        $close_url = $this->params->get('close_url');
        if(!$close_url) $this->params->set('close_url', JURI::root());
        
        $document =& JFactory::getDocument();
        
        // get plugin-template
        $ptemplate = file_get_contents($this->_abs_assets . 'template.html'); 

        $this->params->set('request_key', self::$CookieName);
        
        $params = $this->params->toArray();
        $params = array_keys($params);
        
        // replace placeholders
        foreach($params as $param){
            if(strpos($param, 'smart_api') === true) continue;
            $txt = is_string($this->params->get($param)) ?  nl2br($this->params->get($param)) : $this->params->get($param);
            $ptemplate = str_replace('{{'.$param.'}}', $txt, $ptemplate);
        }
        $ptemplate = preg_replace("/\s+/", ' ', $ptemplate);
        $ptemplate = str_replace('> <', '><', $ptemplate);
        $ptemplate = addslashes($ptemplate);
       
        return $ptemplate;

    }

}
